---
title: Configuring servers for Ogg media
slug: Web/HTTP/Configuring_servers_for_Ogg_media
tags:
  - Audio
  - HTTP
  - Media
  - Ogg
  - Video
---
<div>{{HTTPSidebar}}</div>

<p class="summary">HTML {{HTMLElement("audio")}} and {{HTMLElement("video")}} elements allow media presentation without the need for the user to install any plug-ins or other software to do so. <span class="seoSummary">This guide covers a few server configuration changes that may be necessary for your web server to correctly serve Ogg media files.</span> This information may also be useful if you encounter other media types your server isn't already configured to recognize.</p>

<h2 id="Serve_media_with_the_correct_MIME_type">Serve media with the correct MIME type</h2>

<p><code>*.ogg</code> and <code>*.ogv</code> files containing video (possibly with an audio track as well, of course), should be served with the <code>video/ogg</code> MIME type. <code>*.oga</code> and <code>*.ogg</code> files containing only audio should be served with the <code>audio/ogg</code> MIME type.</p>

<p>If you don't know whether the Ogg file contains audio or video, you can serve it with the MIME type <code>application/ogg</code>, and the browser will treat it as a video file.</p>

<p>Most servers don't by default serve Ogg media with the correct MIME types, so you'll likely need to add the appropriate configuration for this.</p>

<p>For Apache, you can add the following to your configuration:</p>

<pre>AddType audio/ogg .oga
AddType video/ogg .ogv
AddType application/ogg .ogg
</pre>

<p>You can find specific information about possible media file types and the codecs used within them in our comprehensive <a href="/en-US/docs/Web/Media/Formats">guide to media types and formats on the web</a>. In particular, the article on <a href="/en-US/docs/Web/Media/Formats/Containers">media container formats</a> will be especially helpful when configuring serers to host media properly.</p>

<h2 id="Handle_HTTP_1.1_byte_range_requests_correctly">Handle HTTP 1.1 byte range requests correctly</h2>

<p>In order to support seeking and playing back regions of the media that aren't yet downloaded, Gecko uses HTTP 1.1 byte-range requests to retrieve the media from the seek target position. In addition, Gecko uses byte-range requests to seek to the end of the media (assuming you serve the {{HTTPHeader("Content-Length")}} header) in order to determine the duration of the media.</p>

<p>Your server should accept the {{HTTPHeader("Accept-Ranges")}}<code>: bytes</code> HTTP header if it can accept byte-range requests. It must return {{HTTPStatus("206")}}<code>: Partial content</code> to all byte range requests; otherwise, browsers can't be sure you actually support byte range requests.</p>

<p>Your server must also return <code>206: Partial Content</code> for the request <code>Range: bytes=0-</code> as well.</p>

<h2 id="Include_regular_key_frames">Include regular key frames</h2>

<p>When the browser seeks through Ogg media to a specified time, it has to seek to the nearest key frame before the seek target, then download and decode the video from there until the requested target time. The farther apart your key frames are, the longer this takes, so it's helpful to include key frames at regular intervals.</p>

<p>By default, <a class="external" href="http://v2v.cc/~j/ffmpeg2theora/"><code>ffmpeg2theora</code></a> uses one key frame every 64 frames (or about every 2 seconds at 30 frames per second), which works pretty well.</p>

<div class="note"><strong>Note:</strong> Of course, the more key frames you use, the larger your video file is, so you may need to experiment a bit to get the right balance between file size and seek performance.</div>

<h2 id="Consider_using_the_preload_attribute">Consider using the preload attribute</h2>

<p>The HTML {{HTMLElement("audio")}} and {{HTMLElement("video")}} elements provide the <code>preload</code> attribute, which tells the browser to attempt to download the entire media when the page loads. Without <code>preload</code>, the browser only downloads enough of the media to display the first video frame, and to determine the media's duration.</p>

<p><code>preload</code> is off by default, so if getting to video is the point of your web page, your users may appreciate it if you include <code>preload</code> in your video elements. using <code>preload="metadata"</code> will preload the media file's metadata and possibly the first few frames of video. Setting <code>payload</code> to <code>auto</code> tells the browser to automatically begin downloading the media as soon as the page is loaded, under the assumption that the user will play it.</p>

<h2 id="Configuration_for_older_Firefox_versions">Configuration for older Firefox versions</h2>

<h3 id="Serve_X-Content-Duration_headers">Serve X-Content-Duration headers</h3>

<div class="note">
<p><strong>Note</strong>: As of <a href="/en-US/Firefox/Releases/41">Firefox 41</a>, the <code>X-Content-Duration</code> header is no longer supported. See {{Bug(1160695)}} for more details.</p>
</div>

<p>The Ogg format doesn't encapsulate the duration of media, so for the progress bar on the video controls to display the duration of the video, Gecko needs to determine the length of the media using other means.</p>

<p>There are two ways Gecko can do this. The best way is to offer an <code>X-Content-Duration</code> header when serving Ogg media files. This header provides the duration of the video in seconds (<strong>not</strong> in HH:MM:SS format) as a floating-point value.</p>

<p>For example, if the video is 1 minute and 32.6 seconds long, this header would be:</p>

<pre>X-Content-Duration: 92.6
</pre>

<p>If your server provides the <code>X-Content-Duration</code> header when serving Ogg media, Gecko doesn't have to do any extra HTTP requests to seek to the end of the file to calculate its duration. This makes the entire process much more efficient as well as more accurate.</p>

<p>As an inferior alternative, Gecko can estimate the video length based on the Content-Length. See next point.</p>

<h3 id="Don't_use_HTTP_compression_for_media_files">Don't use HTTP compression for media files</h3>

<p>One common way to reduce the load on a web server is to use <a class="external" href="http://betterexplained.com/articles/how-to-optimize-your-site-with-gzip-compression/">gzip or deflate compression</a> when serving to a supporting web browser.</p>

<p>Although it's unlikely, it's possible the browser may advertise that it supports HTTP compression (gzip/deflate) using the <code>Accept-Encoding: gzip,deflate</code> header when requesting media files. Your server should be configured to not do so. The data in media files is already compressed, so you won't get any real benefit from compression, and the use of compression makes it impossible for the browser to properly seek the video or determine its duration.</p>

<p>Another probelm with allowing HTTP compression for media streaming: Apache servers don't send the {{HTTPHeader("Content-Length")}} response header if gzip encoding is used.</p>

<h3 id="Getting_the_duration_of_Ogg_media">Getting the duration of Ogg media</h3>

<p>You can use the <code>oggz-info</code> tool to get the media duration; this tool is included with the <a class="external" href="http://www.xiph.org/oggz/"><code>oggz-tools</code></a> package. The output from <code>oggz-info</code> looks like this:</p>

<pre> $ oggz-info /g/media/bruce_vs_ironman.ogv
 Content-Duration: 00:01:00.046

 Skeleton: serialno 1976223438
         4 packets in 3 pages, 1.3 packets/page, 27.508% Ogg overhead
         Presentation-Time: 0.000
         Basetime: 0.000

 Theora: serialno 0170995062
         1790 packets in 1068 pages, 1.7 packets/page, 1.049% Ogg overhead
         Video-Framerate: 29.983 fps
         Video-Width: 640
         Video-Height: 360

 Vorbis: serialno 0708996688
         4531 packets in 167 pages, 27.1 packets/page, 1.408% Ogg overhead
         Audio-Samplerate: 44100 Hz
         Audio-Channels: 2
</pre>

<p>Note that you can't serve up the reported Content-Duration line reported by <code>oggz-info</code>, because it's reported in HH:MM:SS format. You'll need to convert it to seconds only, then serve that as your <code>X-Content-Duration</code> value. Just parse out the HH, MM, and SS into numbers, then do (HH*3600)+(MM*60)+SS to get the value you should report.</p>

<p>It's important to note that it appears that <code>oggz-info</code> makes a read pass of the media in order to calculate its duration, so it's a good idea to store the duration value in order to avoid lengthy delays while the value is calculated for every HTTP request of your Ogg media.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Media/Formats">Guide to media types and formats on the web</a></li>
 <li><a href="/en-US/docs/Learn/HTML/Multimedia_and_embedding/Video_and_audio_content">Video and audio content</a></li>
 <li><a href="/en-US/docs/Web/Media/Formats/codecs_parameter">The "codecs" parameter in common media types</a></li>
</ul>
